"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.message
import google.protobuf.timestamp_pb2
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

# Plan specifies information about a planned upgrade and when it should occur.
class Plan(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    NAME_FIELD_NUMBER: builtins.int
    TIME_FIELD_NUMBER: builtins.int
    HEIGHT_FIELD_NUMBER: builtins.int
    INFO_FIELD_NUMBER: builtins.int
    UPGRADED_CLIENT_STATE_FIELD_NUMBER: builtins.int
    # Sets the name for the upgrade. This name will be used by the upgraded
    # version of the software to apply any special "on-upgrade" commands during
    # the first BeginBlock method after the upgrade is applied. It is also used
    # to detect whether a software version can handle a given upgrade. If no
    # upgrade handler with this name has been set in the software, it will be
    # assumed that the software is out-of-date when the upgrade Time or Height is
    # reached and the software will exit.
    name: typing.Text = ...
    # Deprecated: Time based upgrades have been deprecated. Time based upgrade logic
    # has been removed from the SDK.
    # If this field is not empty, an error will be thrown.
    @property
    def time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    # The height at which the upgrade must be performed.
    # Only used if Time is not set.
    height: builtins.int = ...
    # Any application specific upgrade info to be included on-chain
    # such as a git commit that validators could automatically upgrade to
    info: typing.Text = ...
    # Deprecated: UpgradedClientState field has been deprecated. IBC upgrade logic has been
    # moved to the IBC module in the sub module 02-client.
    # If this field is not empty, an error will be thrown.
    @property
    def upgraded_client_state(self) -> google.protobuf.any_pb2.Any: ...
    def __init__(self,
        *,
        name : typing.Text = ...,
        time : typing.Optional[google.protobuf.timestamp_pb2.Timestamp] = ...,
        height : builtins.int = ...,
        info : typing.Text = ...,
        upgraded_client_state : typing.Optional[google.protobuf.any_pb2.Any] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal[u"time",b"time",u"upgraded_client_state",b"upgraded_client_state"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"height",b"height",u"info",b"info",u"name",b"name",u"time",b"time",u"upgraded_client_state",b"upgraded_client_state"]) -> None: ...
global___Plan = Plan

# SoftwareUpgradeProposal is a gov Content type for initiating a software
# upgrade.
class SoftwareUpgradeProposal(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TITLE_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    PLAN_FIELD_NUMBER: builtins.int
    title: typing.Text = ...
    description: typing.Text = ...
    @property
    def plan(self) -> global___Plan: ...
    def __init__(self,
        *,
        title : typing.Text = ...,
        description : typing.Text = ...,
        plan : typing.Optional[global___Plan] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal[u"plan",b"plan"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"description",b"description",u"plan",b"plan",u"title",b"title"]) -> None: ...
global___SoftwareUpgradeProposal = SoftwareUpgradeProposal

# CancelSoftwareUpgradeProposal is a gov Content type for cancelling a software
# upgrade.
class CancelSoftwareUpgradeProposal(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    TITLE_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    title: typing.Text = ...
    description: typing.Text = ...
    def __init__(self,
        *,
        title : typing.Text = ...,
        description : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"description",b"description",u"title",b"title"]) -> None: ...
global___CancelSoftwareUpgradeProposal = CancelSoftwareUpgradeProposal

# ModuleVersion specifies a module and its consensus version.
class ModuleVersion(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    NAME_FIELD_NUMBER: builtins.int
    VERSION_FIELD_NUMBER: builtins.int
    # name of the app module
    name: typing.Text = ...
    # consensus version of the app module
    version: builtins.int = ...
    def __init__(self,
        *,
        name : typing.Text = ...,
        version : builtins.int = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"name",b"name",u"version",b"version"]) -> None: ...
global___ModuleVersion = ModuleVersion
